package com.tidecloud.dataacceptance.entity;

/**
 * 位置信息汇报消息
 *
 * @author hylexus
 *
 */
public class LocationInfoUploadMsg extends PackageData {
	// 告警信息
	// byte[0-3]
	private Integer warningFlagField;
	// byte[4-7] 状态(DWORD(32))
	private Integer statusField;
	// byte[8-11] 纬度(DWORD(32))
	private Integer latitude;
	// byte[12-15] 经度(DWORD(32))
	private Integer longitude;
	// byte[16-17] 高程(WORD(16)) 海拔高度，单位为米（ m）
	// TODO ==>int?海拔
	private int elevation;
	// byte[18-19] 速度(WORD) 1/10km/h
	// TODO ==>float?速度
	private Integer speed;
	// byte[20-21] 方向(WORD) 0-359，正北为 0，顺时针
	private Integer direction;
	// byte[22-27] 时间(BCD[6]) YY-MM-DD-hh-mm-ss
	// GMT+8 时间，本标准中之后涉及的时间均采用此时区
	private String time;

	private Integer mileage;
	private Integer oil;
	private Integer gpsState;
	private Integer accState;
	private String fuel;
	
	//累计发动机工作时长
	private Integer accumulatedFdjWorkTime;
	
	//累计行驶/作业时长
	private Integer accumulatedWorkTime;
	
	//累计怠速/怠机时长
	private Integer accumulatedWaitWorkTime;
	
	//累计使用油耗
	private Integer accumulatedOilConsume;
	
	//累计行驶/作业油耗
	private Integer accumulatedWorkOilConsume;
	
	//累计怠速/怠机油耗
	private Integer accumulatedWaitOilConsume;
	
	//瞬时百公里油耗
	private Integer oilConsumeOf100KM;
	
	//瞬时小时油耗
	private Integer oilConsumeOf1Hour;
	
	//开机状态,0:开机 1:停机
	private Integer openStatus;
	//运行状态, 0:怠机/怠速 1:作业/行驶
	private Integer runningStatus;
	
	//异常油耗报警
	private Integer oilExceptWarning;
	//超时怠速报警
	private Integer timeoutWaitWarning;
	//油耗仪故障报警
	private Integer oilDeviceWarning;
	
	
	
    public String getFuel() {
        return fuel;
    }

    public void setFuel(String fuel) {
        this.fuel = fuel;
    }

    public Integer getMileage() {
        return mileage;
    }

    public void setMileage(Integer mileage) {
        this.mileage = mileage;
    }

    public Integer getOil() {
        return oil;
    }

    public void setOil(Integer oil) {
        this.oil = oil;
    }

    public Integer getGpsState() {
        return gpsState;
    }

    public void setGpsState(Integer gpsState) {
        this.gpsState = gpsState;
    }

    public Integer getAccState() {
        return accState;
    }

    public void setAccState(Integer accState) {
        this.accState = accState;
    }

    public LocationInfoUploadMsg() {
	}

	public LocationInfoUploadMsg(PackageData packageData) {
		this();
		this.channel = packageData.getChannel();
		this.checkSum = packageData.getCheckSum();
		this.msgBodyBytes = packageData.getMsgBodyBytes();
		this.msgHeader = packageData.getMsgHeader();
	}

	public int getElevation() {
		return elevation;
	}

	public void setElevation(int elevation) {
		this.elevation = elevation;
	}

	public int getDirection() {
		return direction;
	}

	public void setDirection(int direction) {
		this.direction = direction;
	}

	public String getTime() {
        return time;
    }

    public void setTime(String time) {
        this.time = time;
    }

    public int getWarningFlagField() {
		return warningFlagField;
	}

	public void setWarningFlagField(int warningFlagField) {
		this.warningFlagField = warningFlagField;
	}

	public int getStatusField() {
		return statusField;
	}

	public void setStatusField(int statusField) {
		this.statusField = statusField;
	}

    public void setWarningFlagField(Integer warningFlagField) {
        this.warningFlagField = warningFlagField;
    }

    public void setStatusField(Integer statusField) {
        this.statusField = statusField;
    }

    public void setLatitude(Integer latitude) {
        this.latitude = latitude;
    }

    public void setLongitude(Integer longitude) {
        this.longitude = longitude;
    }

    public void setSpeed(Integer speed) {
        this.speed = speed;
    }

    public void setDirection(Integer direction) {
        this.direction = direction;
    }
    
    public Integer getLatitude() {
        return latitude;
    }

    public Integer getLongitude() {
        return longitude;
    }

    public Integer getSpeed() {
        return speed;
    }

    public Integer getAccumulatedFdjWorkTime() {
		return accumulatedFdjWorkTime;
	}

	public void setAccumulatedFdjWorkTime(Integer accumulatedFdjWorkTime) {
		this.accumulatedFdjWorkTime = accumulatedFdjWorkTime;
	}

	public Integer getAccumulatedWorkTime() {
		return accumulatedWorkTime;
	}

	public void setAccumulatedWorkTime(Integer accumulatedWorkTime) {
		this.accumulatedWorkTime = accumulatedWorkTime;
	}

	public Integer getAccumulatedWaitWorkTime() {
		return accumulatedWaitWorkTime;
	}

	public void setAccumulatedWaitWorkTime(Integer accumulatedWaitWorkTime) {
		this.accumulatedWaitWorkTime = accumulatedWaitWorkTime;
	}

	public Integer getAccumulatedOilConsume() {
		return accumulatedOilConsume;
	}

	public void setAccumulatedOilConsume(Integer accumulatedOilConsume) {
		this.accumulatedOilConsume = accumulatedOilConsume;
	}

	public Integer getAccumulatedWorkOilConsume() {
		return accumulatedWorkOilConsume;
	}

	public void setAccumulatedWorkOilConsume(Integer accumulatedWorkOilConsume) {
		this.accumulatedWorkOilConsume = accumulatedWorkOilConsume;
	}

	public Integer getAccumulatedWaitOilConsume() {
		return accumulatedWaitOilConsume;
	}

	public void setAccumulatedWaitOilConsume(Integer accumulatedWaitOilConsume) {
		this.accumulatedWaitOilConsume = accumulatedWaitOilConsume;
	}

	

	public Integer getOpenStatus() {
		return openStatus;
	}

	public void setOpenStatus(Integer openStatus) {
		this.openStatus = openStatus;
	}

	public Integer getRunningStatus() {
		return runningStatus;
	}

	public void setRunningStatus(Integer runningStatus) {
		this.runningStatus = runningStatus;
	}

	public Integer getOilConsumeOf100KM() {
		return oilConsumeOf100KM;
	}

	public void setOilConsumeOf100KM(Integer oilConsumeOf100KM) {
		this.oilConsumeOf100KM = oilConsumeOf100KM;
	}

	public Integer getOilConsumeOf1Hour() {
		return oilConsumeOf1Hour;
	}

	public void setOilConsumeOf1Hour(Integer oilConsumeOf1Hour) {
		this.oilConsumeOf1Hour = oilConsumeOf1Hour;
	}

	public Integer getOilExceptWarning() {
		return oilExceptWarning;
	}

	public void setOilExceptWarning(Integer oilExceptWarning) {
		this.oilExceptWarning = oilExceptWarning;
	}

	public Integer getTimeoutWaitWarning() {
		return timeoutWaitWarning;
	}

	public void setTimeoutWaitWarning(Integer timeoutWaitWarning) {
		this.timeoutWaitWarning = timeoutWaitWarning;
	}

	public Integer getOilDeviceWarning() {
		return oilDeviceWarning;
	}

	public void setOilDeviceWarning(Integer oilDeviceWarning) {
		this.oilDeviceWarning = oilDeviceWarning;
	}

	@Override
    public String toString() {
        return "LocationInfoUploadMsg [warningFlagField=" + warningFlagField + ", statusField=" + statusField
                + ", latitude=" + latitude + ", longitude=" + longitude + ", elevation=" + elevation + ", speed="
                + speed + ", direction=" + direction + ", time=" + time + ", mileage=" + mileage + ", oil=" + oil
                + ", gpsState=" + gpsState + ", accState=" + accState + ", accumulatedFdjWorkTime=" + accumulatedFdjWorkTime
                + ", accumulatedWorkTime=" + accumulatedWorkTime +", accumulatedWaitWorkTime=" + accumulatedWaitWorkTime
                + ", accumulatedOilConsume=" + accumulatedOilConsume +", accumulatedWorkOilConsume=" + accumulatedWorkOilConsume
                + ", accumulatedWaitOilConsume=" + accumulatedWaitOilConsume +", oilConsumeOf100KM=" + oilConsumeOf100KM
                + ", OilConsumeOf1Hour=" + oilConsumeOf1Hour +", openStatus=" + openStatus+", RunningStatus=" + runningStatus
                +"]";
    }
    
    public static String buildLocationInfo2Str(LocationInfoUploadMsg infoUploadMsg){
        StringBuilder strBuilder = new StringBuilder();
        strBuilder.append(infoUploadMsg.getDeviceId()).append(",");
        strBuilder.append(infoUploadMsg.getTime()).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getLatitude())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getLongitude())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getOil())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getSpeed())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getMileage())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getAccState())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getGpsState())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getFuel())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getOilExceptWarning())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getTimeoutWaitWarning())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getOilDeviceWarning())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getAccumulatedFdjWorkTime())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getAccumulatedWorkTime())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getAccumulatedWaitWorkTime())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getAccumulatedOilConsume())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getAccumulatedWorkOilConsume())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getAccumulatedWaitOilConsume())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getOilConsumeOf100KM())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getOilConsumeOf1Hour())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getOpenStatus())).append(",");
        strBuilder.append(checkoutNullObject(infoUploadMsg.getRunningStatus()));
        return strBuilder.toString();
    }

    private static String checkoutNullObject(Object t){
        if (t == null) {
            return "";
        }
        return String.valueOf(t);
    }
}
